/***



Uncomment "define  YF21" to use the second model

***/

// external libs
#include <irrlicht.h>
#include <iostream>

//#define YF21 1
#define BONEUPDATE



//#pragma comment(lib, "irrlicht.lib")

using namespace std;
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;

IrrlichtDevice* device = NULL;


// Input Receiver
class MyEventReceiver : public IEventReceiver
{
    public:
        MyEventReceiver() :
            oldMouseX(0),
            oldMouseY(0),
            Node(0),
            LoopMode(false)
        {

        }

        //
        virtual bool OnEvent(const SEvent& event)
        {
            if(event.EventType==EET_KEY_INPUT_EVENT && event.KeyInput.PressedDown==false)
            {
                switch(event.KeyInput.Key)
                {
                    case KEY_SPACE:
                        LoopMode = !LoopMode;
                        cout << "changing loopmode to " << LoopMode << endl;
                        Node->setLoopMode( LoopMode );
                        break;

                    case KEY_ESCAPE :
                        cout << "Closing device" << endl;
                        device->closeDevice(); break;

                    case KEY_KEY_A:
                        Node->setFrameLoop(0,5); break;

                    case KEY_KEY_Z:
                        Node->setFrameLoop(5,10); break;

                    case KEY_KEY_E:
                        Node->setFrameLoop(10,15); break;

                    case KEY_KEY_R:
                        Node->setFrameLoop(15,10); break;

                    case KEY_KEY_T:
                        Node->setFrameLoop(10,5); break;

                    // TODO changer la vistesse
                    case KEY_ADD:
                        Node->setAnimationSpeed( Node->getAnimationSpeed() + 0.3 );
                        cout << "changed animation speed to " << Node->getAnimationSpeed()  << endl;
                        break;
                    case KEY_MINUS:
                        Node->setAnimationSpeed( Node->getAnimationSpeed() - 0.3 );break;
                        cout << "changed animation speed to " << Node->getAnimationSpeed()  << endl;
                        break;
                    default: break;
                }
            }
            return false;
        }


        //
        int oldMouseX,oldMouseY;
        bool LoopMode;
        scene::IAnimatedMeshSceneNode* Node;
};

// Main function
int main(int argc, char *argv[])
{
    /////////////////////////////////
    /////// SETUP
    /////////////////////////////////
    const video::E_DRIVER_TYPE chosenDriver = video::EDT_OPENGL;

    MyEventReceiver myEventReceiver;

    // or yf19.b3d
    core::stringc modelFilename("animated/yf19.b3d");
    core::stringc boneName("booster_left");
//EJUOR_CONTROL
    E_JOINT_UPDATE_ON_RENDER mode= EJUOR_READ;







    #ifdef YF21
    modelFilename = "animated/yf21.b3d";
    boneName      = "Bone.047";
    #endif

    //!IRRLICHT
        device = createDevice(chosenDriver,
                core::dimension2d<u32>(640,480),
                32,
                false,
                false,
                false,  // vsync
                &myEventReceiver
                );

    video::IVideoDriver* driver = device->getVideoDriver();
    scene::ISceneManager* smgr = device->getSceneManager();
    gui::IGUIEnvironment* guienv = device->getGUIEnvironment();

    device->setWindowCaption(L"SPARK Basic Demo using Irrlicht");
    device->getCursorControl()->setVisible(false);

    // setup camera
    irr::scene::ICameraSceneNode* cam = smgr->addCameraSceneNodeFPS(smgr->getRootSceneNode(),100.0f,0.05f);
    cam->setPosition( irr::core::vector3df(0.0f,2.5f,2.0f));
    cam->setTarget(   irr::core::vector3df(0.0f,0.0f,0.3f));
    cam->setNearValue(0.05f);




    irr::scene::ISceneManager* scene = device->getSceneManager();

    ////////////////////////////////////////////////
    /////  Creation du mesh / Player
    ////////////////////////////////////////////////../bc0.2/models/animated/
    scene::IAnimatedMesh* mesh = smgr->getMesh( modelFilename.c_str());


//    mesh->setMaterialFlag(video::EMF_LIGHTING, false);


    IAnimatedMeshSceneNode* node = scene->addAnimatedMeshSceneNode(mesh);
    myEventReceiver.Node = node;
    node->setAnimationSpeed(2);

    s32 count = node->getJointCount ();
    for(s32 i = 0; i < count; ++i){
        std::cout << "bone: " << node->getJointNode(i)->getName() << std::endl;
    }


    cout << "AZERTY to set animations, space to change loop mode\n";
    cout << "Model joints count " << count;

    ISceneNode* cube = scene->addCubeSceneNode(1.f);
    //ISceneNode* testCube = scene->addCubeSceneNode(4.f);

    node->setJointMode(mode);


    IBoneSceneNode* bone = node->getJointNode(boneName.c_str());
    if(!bone) {
        std::cout << "node not found";
        return 1;
    }


    cube->setParent( bone );

//        ISceneNode* sphere = scene->addSphereSceneNode(1.0f);


    node->setIsDebugObject(true);
    node->setDebugDataVisible(scene::EDS_SKELETON);

    // setup override material
    driver->getOverrideMaterial().EnableFlags = irr::video::EMF_LIGHTING;
    driver->getOverrideMaterial().Material.setFlag(irr::video::EMF_LIGHTING, false);
    driver->getOverrideMaterial().EnablePasses = irr::scene::ESNRP_SOLID;



    //
    while(device->run())
    {


//        core::vector3df p = bone->getAbsolutePosition(), c = cube->getAbsolutePosition();


        if(mode == EJUOR_CONTROL){
            node->animateJoints(true);
            node->updateAbsolutePosition();
        }
//        sphere->setPosition(bone->getAbsolutePosition());
        //std::cout << "bone pos: " << p.X << "/" << p.Y << "/" << p.Z << std::endl;// << "/" <<
        //std::cout << "cube pos: " << c.X << std::endl;// << "/" <<


        driver->beginScene(true, true, irr::video::SColor(0,0,0,0));

        // Renders scene
        smgr->drawAll();

        driver->endScene();
    }


    device->drop();



//  cout << endl;

    return 0;
}
